""" mapping.py
AE3M33UI - Artificial Intelligence course, FEE CTU in Prague

Module containing mapping functions.
"""

import numpy as np


# noinspection PyPep8Naming
class PolynomialMapping:

    def __init__(self, max_deg=2):
        self.max_deg = max_deg

    def fit(self, X, y=None):
        raise NotImplementedError
        # <YOUR CODE HERE>

    def transform(self, X, y=None):
        """Map the input data x into space of polynomials.
        """
        raise NotImplementedError
        # <YOUR CODE HERE>


# noinspection PyPep8Naming
class FullPolynomialMapping:

    def __init__(self, max_deg=2):
        self.max_deg = max_deg

    def fit(self, X, y=None):
        return self

    def transform(self, X, y=None, max_deg=2):
        """Map X to fully polynomial space, including all crossproducts."""
        raise NotImplementedError
        # <YOUR CODE HERE>
